#version 3.0

// ---------- left ----------

#declare LeftBlack = object
{
   box {<-50,-50,0.5> <50,50,2.5>}
   pigment 
   {
      image_map {gif "bbleft.gif"} 
      scale 100 translate <-50,-50,0>
   }
}

#declare SquareBorder = object
{
   union
   {
      box {<-52.5,-52.5,0> <-50,52.5,3>}
      box {<52.5,-52.5,0> <50,52.5,3>}
      box {<-52.5,-52.5,0> <52.5,-50,3>}
      box {<-52.5,52.5,0> <52.5,50,3>}
   }
   texture {ChromeMetal}
}

#declare Axis = object
{
   union
   {
      cylinder {<0,35,0> <0,45,0> 1}
      cylinder {<0,-5,0> <0,5,0> 1}
      cylinder {<0,-35,0> <0,-45,0> 1}
   }
   texture {ChromeMetal}
}

#declare LeftBoard = object
{
   union
   {
      object {LeftBlack}
      object {SquareBorder}
      object {Axis translate <52.5,0,0>}
   }
   translate <-52.5,0,0>
}

// ---------- right ---------

#declare RightBlack = object
{
   box {<-50,-50,0.5> <50,50,2.5>}
   pigment 
   {
      image_map {gif "bbright.gif"} 
      scale 100 translate <-50,-50,0>
   }
}

#declare RightBoard = object
{
   union
   {
      object {RightBlack}
      object {SquareBorder}
      object {Axis translate <-52.5,0,0>}
   }
   translate <52.5,0,0>
}

// ---------- center ----------

#declare CenterBlack = object
{
   box {<-100,-50,0.5> <100,50,2.5>}
   pigment 
   {
      image_map {gif "bbcenter.gif"} 
      scale <200,100,1> translate <-100,-50,0>
   }
}

#declare CenterBorder = object
{
   union
   {
      box {<-102.5,-52.5,0> <-100,52.5,3>}
      box {<102.5,-52.5,0> <100,52.5,3>}
      box {<-102.5,-52.5,0> <102.5,-50,3>}
      box {<-102.5,52.5,0> <102.5,50,3>}
   }
   texture {ChromeMetal}
}

#declare CenterBoard = object
{
   union 
   {
      object {CenterBlack}
      object {CenterBorder}
   }
}

#declare Latch = object
{
   union
   {
      box { <-100,-52,0.5> <100,-59.5,0> }
      box { <-100,-59,0> <100,-59.5,-10> }
      box { <-100,-59.5,-10> <100,-55,-10.5> }
   }
   texture {ChromeMetal}
}

#declare BlackBoard = object
{
   union
   {
      object {LeftBoard rotate <0,-30,0> translate <-102.5,0,0>}
      object {CenterBoard}
      object {RightBoard rotate <0,0,0> translate <102.5,0,0>}
      object {Latch}
   }
}




