#declare FakeWood = texture
{
   pigment {
      wood
      turbulence 0.04
      ramp_wave
      color_map {
         [0 color rgb<0.45,0.35,0>]
         [0.6 color rgb<0.45,0.25,0>]
         [0.8 color rgb<0.2,0.0,0>]
         [1.0 color rgb<0.4,0.3,0>]
      }
      rotate <1,0,0>
      rotate <0,60,0>
      scale 0.7
   }
   
   finish {
      ambient 0.3
      diffuse 0.8
      phong 0.4
   }
}

#declare GrayMetal = texture
{
   pigment {color rgb<0.6,0.6,0.7>}
   finish {
      brilliance 1.5
      ambient 0.2
      diffuse 0.6
      reflection 0.25
      phong 0.75
      metallic
   }
}

#declare ChromeMetal = texture
{
   pigment {color rgb<0.9,0.9,1.0>}
   finish {
      brilliance 1.5
      ambient 0.2
      diffuse 0.8
      reflection 0.15
      phong 0.75
      metallic
   }
}

#declare TableTop = object      
{
   union
   {
      object { box {<-50,78,-40> <50,80,40>}
         texture {FakeWood}
      }
      object {
         union  {
            intersection {
               cylinder {<-50,79,40-(4/3)> <50,79,40-(4/3)> (5/3)}
               box {<-50,78,40><50,80,40+(1/3)>}
            }
            intersection {
               cylinder {<-50,79,-40+(4/3)> <50,79,-40+(4/3)> (5/3)}
               box {<-50,78,-40><50,80,-40-(1/3)>}
            }
            intersection {
               cylinder {<50-(4/3),79,-40> <50-(4/3),79,40> (5/3)}
               box {<50,78,-40><50+(1/3),80,40>}
            }
            intersection {
               cylinder {<-50+(4/3),79,-40> <-50+(4/3),79,40> (5/3)}
               box {<-50,78,-40><-50-(1/3),80,40>}
            }
         }
         texture {ChromeMetal}
      }
   }
}

#declare TableLeg = object
{
   union
   {
      object
      {
         union
         {
            box {<-1.5,0,-3.5> <1.5,78,3.5>}
            intersection
            {
               box {<-1.5,0,-65> <1.5,10,-3.5>}
               plane {<0,1,0> 0 rotate <-5,0,0> translate <0,10,-3.5>}
            }
         }
         texture {GrayMetal}
      }
      
      object
      {
         intersection
         {
            cylinder {<0,-(12/6),-65> <0,-(12/6),0> (15/6)}
            box {<-1.5,0,-61> <1.5,(3/6),0>}
            rotate <-5,0,0> translate <0,10,-3.5>
         }
         texture {ChromeMetal}
      }

   }
}

#declare Table = object
{
   union
   {
      object {TableTop}
      object {TableLeg translate <-45,0,30>}
      object {TableLeg translate <45,0,30>}
   }
}

